
#
# Copyright (c) 1999-2003 LAAS/CNRS
# All rights reserved.
#
# Redistribution  and  use in source   and binary forms,  with or without
# modification, are permitted provided that  the following conditions are
# met:
#
#   1. Redistributions  of  source code must  retain  the above copyright
#      notice, this list of conditions and the following disclaimer.
#   2. Redistributions in binary form must  reproduce the above copyright
#      notice,  this list of  conditions and  the following disclaimer in
#      the  documentation   and/or  other  materials   provided with  the
#      distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE  AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY  EXPRESS OR IMPLIED WARRANTIES, INCLUDING,  BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES   OF MERCHANTABILITY AND  FITNESS  FOR  A PARTICULAR
# PURPOSE ARE DISCLAIMED.  IN NO  EVENT SHALL THE AUTHOR OR  CONTRIBUTORS
# BE LIABLE FOR ANY DIRECT, INDIRECT,  INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING,  BUT  NOT LIMITED TO, PROCUREMENT  OF
# SUBSTITUTE  GOODS OR SERVICES;  LOSS   OF  USE,  DATA, OR PROFITS;   OR
# BUSINESS  INTERRUPTION) HOWEVER CAUSED AND  ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
# OTHERWISE) ARISING IN ANY WAY OUT OF THE  USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

#
# This file was automagically generated.
# Manual editing not recommended. Changes will be overridden.
#

if { [lsearch [interp hidden] nddInstall] >= 0 } {
    interp expose {} nddInstall
}

proc ::nddInstall { name } {
    foreach rqst { "Init" "GetInit" "SetParams" "SetParamUseTheta" "GetParams" "SetSpeed" "GetSpeed" "ExecTraj" "GoTo" "GoToRelative" "Stop" "RefspeedRefPosterRead" "Goalglobal_goalPosterRead" "Goallocal_goalPosterRead" "GoalmotionChoicePosterRead" "GoalnextToVisitPosterRead" "GoalunusedPosterRead" "DiagramnddDiagramPosterPosterRead" "ParamsParamsPosterRead" "MaxSpeedMaxSpeedPosterRead"  } {
	interp alias {} ${name}::$rqst {} interp invoke {} ndd$rqst $name
    }
}

interp hide {} nddInstall




# Init ----------------------------------------------------------

if { [lsearch [interp hidden] nddInit] >= 0 } {
    interp expose {} nddInit
}
if { [lsearch [interp hidden] nddInitFormatOutput] >= 0 } {
    interp expose {} nddInitFormatOutput
}

proc ::nddInit { name args } {
    set format {}
    lappend format [list { "NDD_INPUT_CART_SEGS" "NDD_INPUT_POLAR_SEGS" "NDD_INPUT_DEBUG" "NDD_INPUT_POLAR_POINTS" "NDD_INPUT_CART_POINTS" } "obst type" "NDD_INPUT_POLAR_SEGS" ]
    lappend format [list int "unused" 0 ]
    lappend format [list string "Obst poster name" "aspectPolarAspect" ]
    lappend format [list string "Pos poster name, or empty string" "pomPos" ]

    return [ ::cs::rqstSend "${name}" "Init" \
	"Set 2D_POINTS source" \
	"NDD_INPUT_POSTERS\n| NDD_OBST_TYPE obstType\n| int unused\n| char obstPosterName\[64\]\n| char currentPosPosterName\[64\]\n" \
	4 \
	$format \
	$args ]
}


proc ::nddInitFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} nddInit
interp hide {} nddInitFormatOutput





# GetInit ----------------------------------------------------------

if { [lsearch [interp hidden] nddGetInit] >= 0 } {
    interp expose {} nddGetInit
}
if { [lsearch [interp hidden] nddGetInitFormatOutput] >= 0 } {
    interp expose {} nddGetInitFormatOutput
}

proc ::nddGetInit { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetInit" \
	"Get 2D_POINTS source" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::nddGetInitFormatOutput { list } {
    set format { {} status { } { inputPosters { } obstType { } unused { } obstPosterName { } currentPosPosterName } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} nddGetInit
interp hide {} nddGetInitFormatOutput





# SetParams ----------------------------------------------------------

if { [lsearch [interp hidden] nddSetParams] >= 0 } {
    interp expose {} nddSetParams
}
if { [lsearch [interp hidden] nddSetParamsFormatOutput] >= 0 } {
    interp expose {} nddSetParamsFormatOutput
}

proc ::nddSetParams { name args } {
    set format {}
    lappend format [list double "Goal Reached when dist < this dist" 0.500000 ]
    lappend format [list double "epsilon for end rotation" 0.200000 ]
    lappend format [list double "Security distance (around sick (urk!)" 0.600000 ]
    lappend format [list double "lmax for the robot (used to give valleys)" 1.000000 ]
    lappend format [list double "distance to take sensor data into account" 10.000000 ]
    lappend format [list double "when this dist from sub goal, choose next one" 1.000000 ]
    lappend format [list double "maximum deceleration" 0.050000 ]
    lappend format [list int "smax parameter (see IROS00)" 18 ]
    lappend format [list int "internal parameter for proportion between angle and speed" 3 ]
    lappend format [list float "nb of cycle to anticipate obstacles (ie, reachable area)" 1.000000 ]
    lappend format [list { "NDD_DONT_USE_THETA" "NDD_USE_THETA" } "end rotation or not" "NDD_USE_THETA" ]

    return [ ::cs::rqstSend "${name}" "SetParams" \
	"Set ndd params to control its behavior" \
	"NDD_PARAMS\n| double distToGoal\n| double epsilonTheta\n| double securityDistance\n| double lmaxRobot\n| double dMaxLocalMap\n| double distSwitchTraj\n| double decelMax\n| int smax\n| int linFactor\n| float enlargementFactor\n| NDD_USING_THETA useTheta\n" \
	11 \
	$format \
	$args ]
}


proc ::nddSetParamsFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} nddSetParams
interp hide {} nddSetParamsFormatOutput





# SetParamUseTheta ----------------------------------------------------------

if { [lsearch [interp hidden] nddSetParamUseTheta] >= 0 } {
    interp expose {} nddSetParamUseTheta
}
if { [lsearch [interp hidden] nddSetParamUseThetaFormatOutput] >= 0 } {
    interp expose {} nddSetParamUseThetaFormatOutput
}

proc ::nddSetParamUseTheta { name args } {
    set format {}
    lappend format [list { "NDD_DONT_USE_THETA" "NDD_USE_THETA" } "end rotation or not" "NDD_USE_THETA" ]

    return [ ::cs::rqstSend "${name}" "SetParamUseTheta" \
	"Set ndd THETA_USE param" \
	"NDD_USING_THETA useTheta\n" \
	1 \
	$format \
	$args ]
}


proc ::nddSetParamUseThetaFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} nddSetParamUseTheta
interp hide {} nddSetParamUseThetaFormatOutput





# GetParams ----------------------------------------------------------

if { [lsearch [interp hidden] nddGetParams] >= 0 } {
    interp expose {} nddGetParams
}
if { [lsearch [interp hidden] nddGetParamsFormatOutput] >= 0 } {
    interp expose {} nddGetParamsFormatOutput
}

proc ::nddGetParams { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetParams" \
	"Get nd2 params" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::nddGetParamsFormatOutput { list } {
    set format { {} status { } { params { } distToGoal { } epsilonTheta { } securityDistance { } lmaxRobot { } dMaxLocalMap { } distSwitchTraj { } decelMax { } smax { } linFactor { } enlargementFactor { } useTheta } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} nddGetParams
interp hide {} nddGetParamsFormatOutput





# SetSpeed ----------------------------------------------------------

if { [lsearch [interp hidden] nddSetSpeed] >= 0 } {
    interp expose {} nddSetSpeed
}
if { [lsearch [interp hidden] nddSetSpeedFormatOutput] >= 0 } {
    interp expose {} nddSetSpeedFormatOutput
}

proc ::nddSetSpeed { name args } {
    set format {}
    lappend format [list double "maximum linear speed" 0 ]
    lappend format [list double "maximum angular speed" 0 ]
    lappend format [list double "maximum linear acceleration" 0 ]
    lappend format [list double "maximum angular acceleration" 0 ]

    return [ ::cs::rqstSend "${name}" "SetSpeed" \
	"Set Maximum speed" \
	"NDD_SPEED\n| double linear\n| double angular\n| double accelLinear\n| double accelAngular\n" \
	4 \
	$format \
	$args ]
}


proc ::nddSetSpeedFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} nddSetSpeed
interp hide {} nddSetSpeedFormatOutput





# GetSpeed ----------------------------------------------------------

if { [lsearch [interp hidden] nddGetSpeed] >= 0 } {
    interp expose {} nddGetSpeed
}
if { [lsearch [interp hidden] nddGetSpeedFormatOutput] >= 0 } {
    interp expose {} nddGetSpeedFormatOutput
}

proc ::nddGetSpeed { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetSpeed" \
	"Get Maximum Speed" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::nddGetSpeedFormatOutput { list } {
    set format { {} status { } { maxSpeed { } linear { } angular { } accelLinear { } accelAngular } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} nddGetSpeed
interp hide {} nddGetSpeedFormatOutput





# ExecTraj ----------------------------------------------------------

if { [lsearch [interp hidden] nddExecTraj] >= 0 } {
    interp expose {} nddExecTraj
}
if { [lsearch [interp hidden] nddExecTrajFormatOutput] >= 0 } {
    interp expose {} nddExecTrajFormatOutput
}

proc ::nddExecTraj { name args } {
    set format {}
    lappend format [list string "trajPosterName.name" "" ]

    return [ ::cs::rqstSend "${name}" "ExecTraj" \
	"ExecTraj path Poster" \
	"NDD_STRING\n| char name\[64\]\n" \
	1 \
	$format \
	$args ]
}


proc ::nddExecTrajFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} nddExecTraj
interp hide {} nddExecTrajFormatOutput





# GoTo ----------------------------------------------------------

if { [lsearch [interp hidden] nddGoTo] >= 0 } {
    interp expose {} nddGoTo
}
if { [lsearch [interp hidden] nddGoToFormatOutput] >= 0 } {
    interp expose {} nddGoToFormatOutput
}

proc ::nddGoTo { name args } {
    set format {}
    lappend format [list double "X in global coordinates" 0 ]
    lappend format [list double "Y in global coordinates" 0 ]
    lappend format [list double "T in global coordinates" 0 ]

    return [ ::cs::rqstSend "${name}" "GoTo" \
	"GoTo goal in global frame" \
	"GENPOS_CART_CONFIG\n| double x\n| double y\n| double theta\n" \
	3 \
	$format \
	$args ]
}


proc ::nddGoToFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} nddGoTo
interp hide {} nddGoToFormatOutput





# GoToRelative ----------------------------------------------------------

if { [lsearch [interp hidden] nddGoToRelative] >= 0 } {
    interp expose {} nddGoToRelative
}
if { [lsearch [interp hidden] nddGoToRelativeFormatOutput] >= 0 } {
    interp expose {} nddGoToRelativeFormatOutput
}

proc ::nddGoToRelative { name args } {
    set format {}
    lappend format [list double "X in robot coordinates" 0 ]
    lappend format [list double "Y in robot coordinates" 0 ]
    lappend format [list double "T in robot coordinates" 0 ]

    return [ ::cs::rqstSend "${name}" "GoToRelative" \
	"GoTo goal in robot frame" \
	"GENPOS_CART_CONFIG\n| double x\n| double y\n| double theta\n" \
	3 \
	$format \
	$args ]
}


proc ::nddGoToRelativeFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} nddGoToRelative
interp hide {} nddGoToRelativeFormatOutput





# Stop ----------------------------------------------------------

if { [lsearch [interp hidden] nddStop] >= 0 } {
    interp expose {} nddStop
}
if { [lsearch [interp hidden] nddStopFormatOutput] >= 0 } {
    interp expose {} nddStopFormatOutput
}

proc ::nddStop { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "Stop" \
	"Stop Motion" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::nddStopFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} nddStop
interp hide {} nddStopFormatOutput





# RefspeedRef ----------------------------------------------------------

if { [lsearch [interp hidden] nddRefspeedRefPosterRead] >= 0 } {
    interp expose {} nddRefspeedRefPosterRead
}
if { [lsearch [interp hidden] nddRefspeedRefPosterFormatOutput] >= 0 } {
    interp expose {} nddRefspeedRefPosterFormatOutput
}

proc ::nddRefspeedRefPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "RefspeedRef" \
	"GENPOS_CART_SPEED\n| int numRef\n| int updatePeriod\n| double v\n| double vt\n| double w\n| double vmax\n| double wmax\n| double linAccelMax\n| double angAccelMax\n" \
	$args ]
}


proc ::nddRefspeedRefPosterFormatOutput { list } {
    set format { {} status { } { speedRef { } numRef { } updatePeriod { } v { } vt { } w { } vmax { } wmax { } linAccelMax { } angAccelMax } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} nddRefspeedRefPosterRead
interp hide {} nddRefspeedRefPosterFormatOutput





# Goalglobal_goal ----------------------------------------------------------

if { [lsearch [interp hidden] nddGoalglobal_goalPosterRead] >= 0 } {
    interp expose {} nddGoalglobal_goalPosterRead
}
if { [lsearch [interp hidden] nddGoalglobal_goalPosterFormatOutput] >= 0 } {
    interp expose {} nddGoalglobal_goalPosterFormatOutput
}

proc ::nddGoalglobal_goalPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "Goalglobal_goal" \
	"GENPOS_CART_CONFIG\n| double x\n| double y\n| double theta\n" \
	$args ]
}


proc ::nddGoalglobal_goalPosterFormatOutput { list } {
    set format { {} status { } { global_goal { } x { } y { } theta } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} nddGoalglobal_goalPosterRead
interp hide {} nddGoalglobal_goalPosterFormatOutput





# Goallocal_goal ----------------------------------------------------------

if { [lsearch [interp hidden] nddGoallocal_goalPosterRead] >= 0 } {
    interp expose {} nddGoallocal_goalPosterRead
}
if { [lsearch [interp hidden] nddGoallocal_goalPosterFormatOutput] >= 0 } {
    interp expose {} nddGoallocal_goalPosterFormatOutput
}

proc ::nddGoallocal_goalPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "Goallocal_goal" \
	"GENPOS_CART_CONFIG\n| double x\n| double y\n| double theta\n" \
	$args ]
}


proc ::nddGoallocal_goalPosterFormatOutput { list } {
    set format { {} status { } { local_goal { } x { } y { } theta } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} nddGoallocal_goalPosterRead
interp hide {} nddGoallocal_goalPosterFormatOutput





# GoalmotionChoice ----------------------------------------------------------

if { [lsearch [interp hidden] nddGoalmotionChoicePosterRead] >= 0 } {
    interp expose {} nddGoalmotionChoicePosterRead
}
if { [lsearch [interp hidden] nddGoalmotionChoicePosterFormatOutput] >= 0 } {
    interp expose {} nddGoalmotionChoicePosterFormatOutput
}

proc ::nddGoalmotionChoicePosterRead { name args } {

    return [ ::cs::posterRead "${name}" "GoalmotionChoice" \
	"NDD_CHOICE\n| double motionDirection\n| double valley\n| double speedPercent\n" \
	$args ]
}


proc ::nddGoalmotionChoicePosterFormatOutput { list } {
    set format { {} status { } { motionChoice { } motionDirection { } valley { } speedPercent } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} nddGoalmotionChoicePosterRead
interp hide {} nddGoalmotionChoicePosterFormatOutput





# GoalnextToVisit ----------------------------------------------------------

if { [lsearch [interp hidden] nddGoalnextToVisitPosterRead] >= 0 } {
    interp expose {} nddGoalnextToVisitPosterRead
}
if { [lsearch [interp hidden] nddGoalnextToVisitPosterFormatOutput] >= 0 } {
    interp expose {} nddGoalnextToVisitPosterFormatOutput
}

proc ::nddGoalnextToVisitPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "GoalnextToVisit" \
	"int nextToVisit\n" \
	$args ]
}


proc ::nddGoalnextToVisitPosterFormatOutput { list } {
    set format { {} status { } nextToVisit }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} nddGoalnextToVisitPosterRead
interp hide {} nddGoalnextToVisitPosterFormatOutput





# Goalunused ----------------------------------------------------------

if { [lsearch [interp hidden] nddGoalunusedPosterRead] >= 0 } {
    interp expose {} nddGoalunusedPosterRead
}
if { [lsearch [interp hidden] nddGoalunusedPosterFormatOutput] >= 0 } {
    interp expose {} nddGoalunusedPosterFormatOutput
}

proc ::nddGoalunusedPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "Goalunused" \
	"int unused\n" \
	$args ]
}


proc ::nddGoalunusedPosterFormatOutput { list } {
    set format { {} status { } unused }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} nddGoalunusedPosterRead
interp hide {} nddGoalunusedPosterFormatOutput





# DiagramnddDiagramPoster ----------------------------------------------------------

if { [lsearch [interp hidden] nddDiagramnddDiagramPosterPosterRead] >= 0 } {
    interp expose {} nddDiagramnddDiagramPosterPosterRead
}
if { [lsearch [interp hidden] nddDiagramnddDiagramPosterPosterFormatOutput] >= 0 } {
    interp expose {} nddDiagramnddDiagramPosterPosterFormatOutput
}

proc ::nddDiagramnddDiagramPosterPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "DiagramnddDiagramPoster" \
	"NDD_DIAGRAM\n| float dmax_sensor\n| float lmax_robot\n| short int nsectors\n| short int currentStrat\n| short int n_valleys\n| short int selected_valley\n| NDD_VALLEY\n| | int begin\n| | int end\n| float pnd\[144\]\n| float rnd\[144\]\n" \
	$args ]
}


proc ::nddDiagramnddDiagramPosterPosterFormatOutput { list } {
    set format { {} status { } { nddDiagramPoster { } dmax_sensor { } lmax_robot { } nsectors { } currentStrat { } n_valleys { } selected_valley { 72 } { valleys { } begin { } end } { 144 } pnd { 144 } rnd } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} nddDiagramnddDiagramPosterPosterRead
interp hide {} nddDiagramnddDiagramPosterPosterFormatOutput





# ParamsParams ----------------------------------------------------------

if { [lsearch [interp hidden] nddParamsParamsPosterRead] >= 0 } {
    interp expose {} nddParamsParamsPosterRead
}
if { [lsearch [interp hidden] nddParamsParamsPosterFormatOutput] >= 0 } {
    interp expose {} nddParamsParamsPosterFormatOutput
}

proc ::nddParamsParamsPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "ParamsParams" \
	"NDD_PARAMS\n| double distToGoal\n| double epsilonTheta\n| double securityDistance\n| double lmaxRobot\n| double dMaxLocalMap\n| double distSwitchTraj\n| double decelMax\n| int smax\n| int linFactor\n| float enlargementFactor\n| NDD_USING_THETA useTheta\n" \
	$args ]
}


proc ::nddParamsParamsPosterFormatOutput { list } {
    set format { {} status { } { Params { } distToGoal { } epsilonTheta { } securityDistance { } lmaxRobot { } dMaxLocalMap { } distSwitchTraj { } decelMax { } smax { } linFactor { } enlargementFactor { } useTheta } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} nddParamsParamsPosterRead
interp hide {} nddParamsParamsPosterFormatOutput





# MaxSpeedMaxSpeed ----------------------------------------------------------

if { [lsearch [interp hidden] nddMaxSpeedMaxSpeedPosterRead] >= 0 } {
    interp expose {} nddMaxSpeedMaxSpeedPosterRead
}
if { [lsearch [interp hidden] nddMaxSpeedMaxSpeedPosterFormatOutput] >= 0 } {
    interp expose {} nddMaxSpeedMaxSpeedPosterFormatOutput
}

proc ::nddMaxSpeedMaxSpeedPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "MaxSpeedMaxSpeed" \
	"NDD_SPEED\n| double linear\n| double angular\n| double accelLinear\n| double accelAngular\n" \
	$args ]
}


proc ::nddMaxSpeedMaxSpeedPosterFormatOutput { list } {
    set format { {} status { } { MaxSpeed { } linear { } angular { } accelLinear { } accelAngular } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} nddMaxSpeedMaxSpeedPosterRead
interp hide {} nddMaxSpeedMaxSpeedPosterFormatOutput


